source: common/common-functions@ 0f3eb9f

1.0 2.3 2.3.x 2.4 ablfs ablfs-more legacy new_features trunk
Last change on this file since 0f3eb9f was 0f3eb9f, checked in by Manuel Canales Esparcia <manuel@…>, 18 years ago

Removed remainig references to alphabetical and udev_update branches.

  • Property mode set to 100644
File size: 25.7 KB
Line 
1#!/bin/bash
2
3# $Id$
4
5set +e
6
7# VT100 colors
8declare -r BLACK=$'\e[1;30m'
9declare -r DK_GRAY=$'\e[0;30m'
10
11declare -r RED=$'\e[31m'
12declare -r GREEN=$'\e[32m'
13declare -r YELLOW=$'\e[33m'
14declare -r BLUE=$'\e[34m'
15declare -r MAGENTA=$'\e[35m'
16declare -r CYAN=$'\e[36m'
17declare -r WHITE=$'\e[37m'
18
19declare -r OFF=$'\e[0m'
20declare -r BOLD=$'\e[1m'
21declare -r REVERSE=$'\e[7m'
22declare -r HIDDEN=$'\e[8m'
23
24declare -r tab_=$'\t'
25declare -r nl_=$'\n'
26
27declare -r DD_BORDER="${BOLD}${WHITE}==============================================================================${OFF}"
28declare -r SD_BORDER="${BOLD}${WHITE}------------------------------------------------------------------------------${OFF}"
29declare -r STAR_BORDER="${BOLD}${WHITE}******************************************************************************${OFF}"
30
31# bold yellow > < pair
32declare -r R_arrow=$'\e[1;33m>\e[0m'
33declare -r L_arrow=$'\e[1;33m<\e[0m'
34
35
36usage() {
37cat <<- -EOF-
38${DD_BORDER}
39${BOLD}
40 Usage: $0 ${BOLD}[OPTION]
41
42Options:
43${BOLD} -h, --help${OFF}
44 print this help, then exit
45
46${BOLD} -V, --version${OFF}
47 print version information, then exit
48
49${BOLD} -B, --book VER${OFF}
50 checkout VER version of the book. Supported versions at this time are:
51 dev* | trunk | SVN aliases for Development {C,H,B}LFS
52
53${BOLD} -D --directory DIR${OFF}
54 use DIR directory for building ${BOLD}$(echo $PROGNAME | tr [a-z] [A-Z])${OFF}; all files jhalfs produces
55 will be in the directory DIR/jhalfs.
56
57${BOLD} -G, --get-packages${OFF}
58 download the packages and patches. This assumes that the server declared
59 in the configuration file has the proper packages and patches for the
60 book version being processed.
61
62${BOLD} -T, --testsuites N ${OFF}
63 Run test suites [0-3]
64 0 = none
65 1 = only chapter06 Glibc, GCC and Binutils testsuites
66 2 = all chapter06 testsuites (in BLFS, alias to 1)
67 3 = all chapter05 and chapter06 testsuites
68 In BLFS, 2 and 3 are aliases to 1
69 In CLFS, 3 is an alias to 2
70
71${BOLD} -W, --working-copy DIR${OFF}
72 use the local working copy placed in DIR as the $(echo $PROGNAME | tr [a-z] [A-Z]) book
73-EOF-
74
75[[ ${PROGNAME} != "blfs" ]] &&
76cat <<- -EOF-
77
78${BOLD} -C, --comparasion TYPE${OFF}
79 do iterative comparison analysis. That will take several time due that
80 the final system packages wil be rebuilded the times defined in the
81 ITERATIONS config option.
82 Analisys types allowed are:
83 ICA = do the ICA analysis designed by Greg Schafer
84 farce = do the farce analysis designed by Ken Moffat
85 both = perfom both ICA and farce analysis
86
87${BOLD} -F, --fstab FILE${OFF}
88 use FILE as the /etc/fstab file for the ${BOLD}$(echo $PROGNAME | tr [a-z] [A-Z])${OFF} system. If not specified,
89 a default /etc/fstab file with dummy values is created.
90
91${BOLD} -K, --kernel-config FILE${OFF}
92 use the kernel configuration file specified in FILE to build the kernel.
93 if the file is not found, or if not specified, the kernel build is skipped.
94
95${BOLD} -M, --run-make${OFF}
96 run make on the generated Makefile
97
98${BOLD} -R --rebuild${OFF}
99 clean the build directory before to perfom any other task. The directory
100 is cleaned only if it was populated by a previous jhalfs run.
101-EOF-
102
103[[ ${PROGNAME} = "clfs" ]] &&
104cat <<- -EOF-
105
106${BOLD} -A, --arch ARCH ${OFF}
107 Select the TARGET architecture, valid selections are:
108 32bit builds
109 x86, i486, i586, ppc, mips, mipsel, sparc
110 64bit builds
111 x86_64-64, mips64-64, mipsel64-64, sparc64-64, alpha
112 64bit multi-lib
113 x86_64, mips64, mipsel64, sparc64, ppc64
114
115${BOLD} --boot-config FILE ${OFF}
116 The configuration file for the bootstrap kernel if method=boot
117
118${BOLD} --method BUILDMETHOD ${OFF}
119 Select the build method, chroot or boot
120-EOF-
121
122[[ ${PROGNAME} = "hlfs" ]] &&
123cat <<- -EOF-
124
125${BOLD} --model STYLE ${OFF}
126 Select the library model for the HLFS system
127 Valid choices are: glibc or uclibc
128-EOF-
129
130[[ ${PROGNAME} = "blfs" ]] &&
131cat <<- -EOF-
132
133${BOLD} --dependencies 0/1/2${OFF}
134 add dependencies of type TYPE to the build tree.
135 If not set, both required and recommended are used.
136
137 Possible values are:
138 0 - required only required dependecies are used
139 1 - recommended both required a recommended dependencies are used
140 2 - optional all dependencies are used
141-EOF-
142
143cat <<- -EOF-
144${DD_BORDER}
145-EOF-
146 exit
147}
148
149version="
150${BOLD} \"jhalfs\"${OFF} builder tool (development) \$Rev$
151\$Date$
152
153${BOLD} \"${PROGNAME}\"${OFF} script module
154
155Written by George Boudreau,
156 Manuel Canales Esparcia,
157 Jeremy Huntwork
158
159This program is published under the ${BOLD}Gnu General Public License, Version 2.${OFF}
160"
161
162
163no_empty_builddir() {
164 'clear'
165cat <<- -EOF-
166${DD_BORDER}
167
168${tab_}${tab_}${BOLD}${RED}W A R N I N G${OFF}
169 Looks like the \$BUILDDIR directory contains subdirectories
170 from a previous HLFS build.
171
172 Please format the partition mounted on \$BUILDDIR or set
173 a different build directory before running jhalfs.
174${OFF}
175${DD_BORDER}
176-EOF-
177 exit
178}
179
180
181help="${nl_}Try '$0 --help' for more information."
182
183
184exit_missing_arg="\
185echo \"Option '\$1' requires an argument\" >&2
186echo \"\$help\" >&2
187exit 1"
188
189no_dl_client="\
190echo \"Could not find a way to download the ${BOLD}$(echo $PROGNAME | tr [a-z] [A-Z])${OFF} sources.\" >&2
191echo \"Attempting to continue.\" >&2"
192
193HEADER="# This file is automatically generated by jhalfs
194# DO NOT EDIT THIS FILE MANUALLY
195#
196# Generated on `date \"+%F %X %Z\"`"
197
198
199
200
201
202#----------------------------------#
203wrt_target() { # Create target and initialize log file
204#----------------------------------#
205 local i=$1
206 local PREV=$2
207(
208cat << EOF
209
210$i: $PREV
211 @\$(call echo_message, Building)
212 @echo -e "\n\`date\`\n\nKB: \`du -skx --exclude=jhalfs \$(MOUNT_PT)\`\n" >logs/$this_script
213EOF
214) >> $MKFILE.tmp
215}
216
217
218#----------------------------------#
219wrt_unpack() { # Unpack and set 'ROOT' var
220#----------------------------------#
221 local FILE=$1
222(
223cat << EOF
224 @\$(call unpack,$FILE)
225 @ROOT=\`head -n1 /tmp/unpacked | sed 's@^./@@;s@/.*@@'\` && \\
226 echo "export PKGDIR=\$(MOUNT_PT)\$(SRC)/\$\$ROOT" > envars && \\
227 chown -R lfs \$(MOUNT_PT)\$(SRC)/\$\$ROOT
228EOF
229) >> $MKFILE.tmp
230}
231
232
233#----------------------------------#
234wrt_unpack2() { #
235#----------------------------------#
236 local FILE=$1
237(
238cat << EOF
239 @\$(call unpack2,$FILE)
240 @ROOT=\`head -n1 /tmp/unpacked | sed 's@^./@@;s@/.*@@'\` && \\
241 echo "export PKGDIR=\$(SRC)/\$\$ROOT" > envars
242EOF
243) >> $MKFILE.tmp
244}
245
246
247#=============================#
248wrt_unpack3() { #
249#=============================#
250 local FILE=$1
251(
252cat << EOF
253 @\$(call unpack3,$FILE)
254 @ROOT=\`head -n1 /tmp/unpacked | sed 's@^./@@;s@/.*@@'\` && \\
255 echo "export PKGDIR=\$(SRC)/\$\$ROOT" > envars
256EOF
257) >> $MKFILE.tmp
258}
259
260
261
262#----------------------------------#
263wrt_target_vars() { # Target vars for hlfs (cross-build method)
264#----------------------------------#
265(
266cat << EOF
267 @echo "export target=$(uname -m)-${TARGET}" >> envars && \\
268 echo "export ldso=/lib/${LOADER}" >> envars
269EOF
270) >> $MKFILE.tmp
271
272}
273
274
275#----------------------------------#
276wrt_run_as_su() { # Execute script inside time { }, footer to log file
277#----------------------------------#
278 local this_script=$1
279 local file=$2
280(
281cat << EOF
282 @( time { su - lfs -c "source /home/lfs/.bashrc && $JHALFSDIR/${PROGNAME}-commands/$file" >>logs/$this_script 2>&1 ; } ) 2>>logs/$this_script && \\
283 echo -e "\nKB: \`du -skx --exclude=jhalfs \$(MOUNT_PT)\`\n" >>logs/$this_script
284EOF
285) >> $MKFILE.tmp
286}
287
288
289#----------------------------------#
290wrt_run_as_root() { # Some scripts must be run as root..
291#----------------------------------#
292 local this_script=$1
293 local file=$2
294(
295cat << EOF
296 @( time { export LFS=\$(MOUNT_PT) && ${PROGNAME}-commands/$file >>logs/$this_script 2>&1 ; } ) 2>>logs/$this_script && \\
297 echo -e "\nKB: \`du -skx --exclude=jhalfs \$(MOUNT_PT)\`\n" >>logs/$this_script
298EOF
299) >> $MKFILE.tmp
300}
301
302
303#=============================#
304wrt_run_as_root2() { #
305#=============================#
306 local this_script=$1
307 local file=$2
308(
309cat << EOF
310 @( time { source envars && ${PROGNAME}-commands/$file >>logs/$this_script 2>&1 ; } ) 2>>logs/$this_script && \\
311 echo -e "\nKB: \`du -skx --exclude=jhalfs \`\n" >>logs/$this_script
312EOF
313) >> $MKFILE.tmp
314}
315
316
317
318#----------------------------------#
319wrt_run_as_chroot1() { #
320#----------------------------------#
321 local this_script=$1
322 local file=$2
323(
324 cat << EOF
325 @( time { \$(CHROOT1) 'cd /jhalfs && source envars && /jhalfs/${PROGNAME}-commands/$file >>/jhalfs/logs/${this_script} 2>&1' ; } ) 2>>logs/$this_script && \\
326 echo -e "\nKB: \`du -skx --exclude=jhalfs \$(MOUNT_PT)\`\n" >>logs/${this_script}
327EOF
328) >> $MKFILE.tmp
329}
330
331
332#----------------------------------#
333wrt_run_as_chroot2() { #
334#----------------------------------#
335 local this_script=$1
336 local file=$2
337(
338cat << EOF
339 @( time { \$(CHROOT2) 'cd /jhalfs && source envars && /jhalfs/${PROGNAME}-commands/$file >>/jhalfs/logs/${this_script} 2>&1' ; } ) 2>>logs/$this_script && \\
340 echo -e "\nKB: \`du -skx --exclude=jhalfs \$(MOUNT_PT)\`\n" >>logs/${this_script}
341EOF
342) >> $MKFILE.tmp
343}
344
345
346#----------------------------------#
347wrt_copy_fstab() { #
348#----------------------------------#
349 local i=$1
350(
351 cat << EOF
352 @cp -v $FSTAB \$(MOUNT_PT)/etc/fstab >>logs/$i 2>&1
353EOF
354) >> $MKFILE.tmp
355}
356
357#----------------------------------#
358wrt_copy_fstab2() { #
359#----------------------------------#
360 local i=$1
361(
362 cat << EOF
363 @cp -v /sources/fstab /etc/fstab >>logs/$i 2>&1
364EOF
365) >> $MKFILE.tmp
366}
367
368
369#----------------------------------#
370wrt_remove_build_dirs() { #
371#----------------------------------#
372 local name=$1
373(
374cat << EOF
375 @ROOT=\`head -n1 /tmp/unpacked | sed 's@^./@@;s@/.*@@'\` && \\
376 rm -r \$(MOUNT_PT)\$(SRC)/\$\$ROOT && \\
377 if [ -e \$(MOUNT_PT)\$(SRC)/$name-build ]; then \\
378 rm -r \$(MOUNT_PT)\$(SRC)/$name-build; \\
379 fi;
380EOF
381) >> $MKFILE.tmp
382}
383
384
385#----------------------------------#
386wrt_remove_build_dirs2() { #
387#----------------------------------#
388 local name=$1
389(
390cat << EOF
391 @ROOT=\`head -n1 /tmp/unpacked | sed 's@^./@@;s@/.*@@'\` && \\
392 rm -r \$(SRC)/\$\$ROOT && \\
393 if [ -e \$(SRC)/$name-build ]; then \\
394 rm -r \$(SRC)/$name-build; \\
395 fi;
396EOF
397) >> $MKFILE.tmp
398}
399
400
401#----------------------------------#
402wrt_report() { #
403#----------------------------------#
404(
405cat << EOF
406
407create-sbu_du-report: $PREV
408 @\$(call echo_message, Building)
409 @./create-sbu_du-report.sh logs $VERSION
410 @\$(call echo_report,$VERSION-SBU_DU-$(date --iso-8601).report)
411 @touch \$@
412EOF
413) >> $MKFILE.tmp
414
415chapter789="$chapter789 create-sbu_du-report"
416}
417
418
419#----------------------------#
420run_make() {
421#----------------------------#
422 # Test if make must be run.
423 if [ "$RUNMAKE" = "1" ] ; then
424 # Test to make sure we're running the build as root
425 if [ "$UID" != "0" ] ; then
426 echo "You must be logged in as root to successfully build the system."
427 exit 1
428 fi
429 # Build the system
430 if [ -e $MKFILE ] ; then
431 echo -ne "Building the system...\n"
432 cd $JHALFSDIR && make
433 echo -ne "done\n"
434 fi
435 fi
436}
437
438
439#----------------------------#
440clean_builddir() {
441#----------------------------#
442 # Test if the clean must be done.
443 if [ "$CLEAN" = "1" ] ; then
444 # Test to make sure we're running the clean as root
445 if [ "$UID" != "0" ] ; then
446 echo "You must be logged in as root to clean the build directory."
447 exit 1
448 fi
449 # Test to make sure that the build directory was populated by jhalfs
450 if [ ! -d $JHALFSDIR ] || [ ! -d $BUILDDIR/sources ] ; then
451 echo "Looks like $BUILDDIR was not populated by a previous jhalfs run."
452 exit 1
453 else
454 # Clean the build directory
455 echo -ne "Cleaning $BUILDDIR...\n"
456 rm -rf $BUILDDIR/{bin,boot,dev,etc,home,lib,media,mnt,opt,proc,root,sbin,srv,sys,tmp,tools,cross-tools,usr,var}
457 echo -ne "Cleaning $JHALFSDIR...\n"
458 rm -rf $JHALFSDIR/{0*,1*,envars,sources-dir,*commands,logs,Makefile,*.xsl,makefile-functions,packages,patches}
459 echo -ne "Cleaning remainig extracted sources in $BUILDDIR/sources...\n"
460 rm -rf `find $BUILDDIR/sources/* -maxdepth 0 -type d`
461 echo -ne "done\n"
462 fi
463 fi
464}
465
466#----------------------------#
467get_book() {
468#----------------------------#
469 cd $JHALFSDIR
470
471 if [ -z $WC ] ; then
472 # Check for Subversion instead of just letting the script hit 'svn' and fail.
473 test `type -p svn` || eval "echo \"This feature requires Subversion.\"
474 exit 1"
475 echo -n "Downloading the $PROGNAME document, $LFSVRS version... "
476
477 case $PROGNAME in
478 lfs) svn_root="LFS" ;;
479 hlfs) svn_root="HLFS" ;;
480 clfs) svn_root="cross-lfs" ;;
481 blfs) svn_root="BLFS" ;;
482 *) echo "BOOK not defined in function <get_book>"
483 exit 1 ;;
484 esac
485 # Grab a fresh book if it's missing, otherwise, update it from the
486 # repo. If we've already extracted the commands, move on to getting the
487 # sources.
488 if [ -d ${PROGNAME}-$LFSVRS ] ; then
489 cd ${PROGNAME}-$LFSVRS
490 if LC_ALL=C svn up | grep -q At && test -d $JHALFSDIR/commands && \
491 test -f $JHALFSDIR/packages && test -f $JHALFSDIR/patches ; then
492 echo -ne "done\n"
493 # Set the canonical book version
494 cd $JHALFSDIR
495 VERSION=`grep "ENTITY version " $BOOK/general.ent | sed 's@<!ENTITY version "@@;s@">@@'`
496 get_sources
497 else
498 echo -ne "done\n"
499 # Set the canonical book version
500 cd $JHALFSDIR
501 VERSION=`grep "ENTITY version " $BOOK/general.ent | sed 's@<!ENTITY version "@@;s@">@@'`
502 extract_commands
503 fi
504 else
505 case $LFSVRS in
506 development)
507 svn co $SVN/${svn_root}/trunk/BOOK ${PROGNAME}-$LFSVRS >>$LOGDIR/$LOG 2>&1 ;;
508 esac
509 echo -ne "done\n"
510 # Set the canonical book version
511 cd $JHALFSDIR
512 VERSION=`grep "ENTITY version " $BOOK/general.ent | sed 's@<!ENTITY version "@@;s@">@@'`
513 extract_commands
514 fi
515 else
516 echo -ne "Using $BOOK as book's sources ...\n"
517 # Set the canonical book version
518 cd $JHALFSDIR
519 VERSION=`grep "ENTITY version " $BOOK/general.ent | sed 's@<!ENTITY version "@@;s@">@@'`
520 extract_commands
521 fi
522}
523
524
525#----------------------------#
526build_patches_file() { # Supply a suitably formated list of patches.
527#----------------------------#
528 local saveIFS=$IFS
529 local IFS
530
531 rm -f patches
532
533 LOC_add_patches_entry() {
534 for f in `grep "/$1-" patcheslist_.wget`; do
535 basename $f | sed "s|${2}|\&${1}-version;|" >> patches
536 done
537 }
538
539 case ${PROGNAME} in
540 hlfs)
541 echo -n "Creating the HLFS ${L_arrow}${BOLD}$MODEL${R_arrow} specific patches file"
542 xsltproc --nonet \
543 --xinclude \
544 --stringparam model $MODEL \
545 -o patcheslist_.wget \
546 patcheslist.xsl \
547 $BOOK/chapter04/patches.xml
548 #> /dev/null 2>&1
549
550 # .... U G L Y .... what to do with the grsecurity patch to the kernel..
551 for f in `grep "/grsecurity-" patcheslist_.wget`; do
552 basename $f >> patches
553 done
554 ;;
555
556 clfs) # Pull out a list of arch specific patches
557 echo -n "Creating CLFS ${L_arrow}${BOLD}$ARCH${R_arrow} specific patches file"
558 xsltproc -xinclude \
559 -o patcheslist_.wget \
560 patcheslist.xsl \
561 $BOOK/materials/${ARCH}-chapter.xml
562 ;;
563 *) return
564 esac
565
566
567 IFS=$'\x0A' # Modify the 'internal field separator' to break on 'LF' only
568 for f in `cat packages`; do
569 IFS=$saveIFS # Restore the system defaults
570 LOC_add_patches_entry \
571 `echo $f | sed -e 's/-version//' \
572 -e 's/-file.*//' \
573 -e 's/"//g' \
574 -e 's/uclibc/uClibc/'`
575 done
576
577 rm -f patcheslist_.wget
578
579 echo " ...OK"
580}
581
582
583#----------------------------#
584extract_commands() { #
585#----------------------------#
586 local saveIFS=$IFS
587
588 # Check for libxslt instead of just letting the script hit 'xsltproc' and fail.
589 test `type -p xsltproc` || eval "echo \"This feature requires libxslt.\"
590 exit 1"
591
592 cd $JHALFSDIR
593 VERSION=`grep "ENTITY version " $BOOK/general.ent | sed 's@<!ENTITY version "@@;s@">@@'`
594
595 # Start clean
596 if [ -d ${PROGNAME}-commands ]; then
597 rm -rf ${PROGNAME}-commands
598 mkdir -v ${PROGNAME}-commands
599 fi
600 echo -n "Extracting commands for"
601
602 # Dump the commands in shell script form from the HLFS book.
603 case ${PROGNAME} in
604 clfs)
605 echo -n " ${L_arrow}${BOLD}$ARCH${R_arrow} target architecture"
606 xsltproc --nonet \
607 --xinclude \
608 --stringparam method $METHOD \
609 --stringparam testsuite $TEST \
610 --stringparam vim-lang $VIMLANG \
611 --stringparam timezone $TIMEZONE \
612 --stringparam page $PAGE \
613 --stringparam lang $LANG \
614 --stringparam keymap $KEYMAP \
615 -o ./${PROGNAME}-commands/ $XSL $BOOK/$ARCH-index.xml >>$LOGDIR/$LOG 2>&1
616 ;;
617 hlfs)
618 echo -n " ${L_arrow}${BOLD}$MODEL${R_arrow} HLFS libc implementation"
619 xsltproc --nonet \
620 --xinclude \
621 --stringparam model $MODEL \
622 --stringparam testsuite $TEST \
623 --stringparam timezone $TIMEZONE \
624 --stringparam page $PAGE \
625 --stringparam lang $LANG \
626 --stringparam lc_all $LC_ALL \
627 --stringparam keymap $KEYMAP \
628 --stringparam grsecurity_host $GRSECURITY_HOST \
629 -o ./${PROGNAME}-commands/ $XSL $BOOK/index.xml >>$LOGDIR/$LOG 2>&1
630 ;;
631 lfs)
632 echo -n " ${L_arrow}${BOLD}LFS${R_arrow} build"
633 xsltproc --nonet \
634 --xinclude \
635 --stringparam testsuite $TEST \
636 --stringparam vim-lang $VIMLANG \
637 --stringparam timezone $TIMEZONE \
638 --stringparam page $PAGE \
639 --stringparam lang $LANG \
640 -o ./${PROGNAME}-commands/ $XSL $BOOK/index.xml >>$LOGDIR/$LOG 2>&1
641 ;;
642 blfs)
643 echo -n " ${L_arrow}${BOLD}BLFS${R_arrow} build"
644 xsltproc --nonet \
645 --xinclude \
646 --stringparam testsuite $TEST \
647 --stringparam server $SERVER \
648 -o ./${PROGNAME}-commands/ $XSL $BOOK/index.xml >>$LOGDIR/$LOG 2>&1
649 ;;
650 *) exit 1
651 esac
652
653 echo " ...OK"
654
655 # Make the scripts executable.
656 chmod -R +x $JHALFSDIR/${PROGNAME}-commands
657
658 # Grab the patches and package names.
659 for i in patches packages ; do
660 rm -f $i
661 done
662 #
663 case "${PROGNAME}" in
664 clfs)
665 ################################
666 # A LOCAL function
667 # xx_.wget contains arch specific files but in URL format
668 # Build a file with only arch specific files.. small ugly..
669 LOC_add_packages_entry() {
670 local fileMATCH aFILE
671
672 # Deal with a non-standard format
673 if [[ "$1" = "clfs-bootscripts" ]]; then
674 set -- "bootscripts-cross-lfs" $2
675 fi
676 fileMATCH="/$1"
677
678 # format.. Filename-Version or FilenameVersion
679 for aFILE in `grep ${fileMATCH}-*[[:digit:]] packageslist_.wget`; do
680 # Block vim-x.x-lang file, will add it later based on config flag
681 if [[ ! "${aFILE}" =~ "vim-$2-lang" ]]; then
682 echo "$1-version \"$2\"" >> packages
683 fi
684 done
685 }
686 #################################
687
688 # We only want a list arch specific files..
689 # Unfortunately this script produces URL's which must be converted to a std format
690 echo -n "Creating CLFS ${L_arrow}${BOLD}${ARCH}${R_arrow} specific packages file"
691 xsltproc -xinclude \
692 -o packageslist_.wget \
693 packageslist.xsl \
694 $BOOK/materials/${ARCH}-chapter.xml
695
696 # This has the correct format but contains packages from every book
697 grep "\-version " $BOOK/packages.ent | sed -e 's@<!ENTITY @@' \
698 -e 's@">@"@' \
699 -e '/generic/d' > packages.tmp
700 # This variable is necessary to make sure the `cat $JHALFSDIR/packages`
701 # separates each iteration by lines.
702 # Modify the 'internal field separator' to break on 'LF' only
703 IFS=$'\x0A'
704 for f in `cat packages.tmp`; do
705 IFS=$saveIFS # Restore the system defaults
706 LOC_add_packages_entry \
707 `echo $f | sed -e 's/-version//' \
708 -e 's/-file.*//' \
709 -e 's/"//g'`
710 done
711
712 rm -f packageslist_.wget packages.tmp
713
714 echo " ...OK"
715 ;;
716
717 hlfs)
718 echo -n "Creating <${PROGNAME}> specific packages file"
719 grep "\-version" $BOOK/general.ent | sed -e 's@<!ENTITY @@' \
720 -e 's@">@"@' \
721 -e '/generic/d' >> packages
722 echo " ...OK"
723 ;;
724
725 lfs)
726 echo -n "Creating <${PROGNAME}> specific packages file"
727 grep "\-version" $BOOK/general.ent | sed -e 's@<!ENTITY @@' \
728 -e 's@">@"@' \
729 -e '/generic/d' >> packages
730 echo `grep "glibc" packages | sed 's@glibc@glibc-libidn@'` >> packages
731 echo `grep "udev-config-file" $BOOK/general.ent | sed -e 's@<!ENTITY @@' -e 's@">@"@'` >> packages
732 echo " ...OK"
733 ;;
734 esac
735
736 # Download the vim-lang package if it must be installed
737 if [ "$VIMLANG" = "1" ] && [ ! "$PROGNAME" = "hlfs" ] ; then
738 echo `grep "vim" packages | sed 's@vim@&-lang@'` >> packages
739 fi
740
741 # Create the patches file
742 case "${PROGNAME}" in
743 hlfs)
744 build_patches_file ;;
745 clfs )
746 build_patches_file ;;
747 lfs)
748 grep "^<\!ENTITY" $BOOK/patches.ent | sed -e 's/.* "//' -e 's/">//' >> patches
749 ;;
750 blfs) ;;
751 *) exit 1
752 esac
753
754 # Done. Moving on...
755 get_sources
756}
757
758
759#----------------------------#
760download() { # Download file, write name to MISSING_FILES.DMP if an error
761#----------------------------#
762 cd $BUILDDIR/sources
763
764 # Hackish fix for the bash-doc, glibc-{linuxthreads,libidn}
765 # that don't conform to norms in the URL scheme.
766 DIR=`echo $1 | sed 's@-doc@@;s@-linuxthreads@@;s@-libidn@@;s@-testsuite@@'`
767
768 # If the file exists in the archive copy it to the $BUILDDIR/sources dir
769 # MD5SUM is assumed to be correct from previous download
770 if [ ! -z ${SRC_ARCHIVE} ] &&
771 [ -d ${SRC_ARCHIVE} ] &&
772 [ -f ${SRC_ARCHIVE}/$2 ]; then
773 cp ${SRC_ARCHIVE}/$2 .
774 echo "$2: -- ok"
775 return
776 fi
777
778 # Find the md5 sum for this package.
779 if [ $2 != MD5SUMS ] ; then
780 set +e
781 MD5=`grep " $2" MD5SUMS`
782 if [ $? -ne 0 ]; then
783 set -e
784 echo "${RED}$2 not found in MD5SUMS${OFF}"
785 echo "$2 not found in MD5SUMS" >> MISSING_FILES.DMP
786 return
787 fi
788 set -e
789 fi
790
791 if [ ! -f $2 ] ; then
792 case $DL in
793 wgetFTP ) wget --passive $FTP/$DIR/$2 ;;
794 wget ) wget $HTTP/$DIR/$2 ;;
795 curl ) `curl -# $FTP/$DIR/$2 -o $2` ;;
796 * ) echo "$DL not supported at this time." ;;
797 esac
798 elif ! echo "$MD5" | md5sum -c - >/dev/null 2>/dev/null ; then
799 case $DL in
800 wgetFTP ) wget --passive -c $FTP/$DIR/$2 ;;
801 wget ) wget -c $HTTP/$DIR/$2 ;;
802 curl ) `curl -# -C - $FTP/$DIR/$2 -o $2` ;;
803 * ) echo "$DL not supported at this time." ;;
804 esac
805 fi
806
807 if [ $2 != MD5SUMS ] && ! echo "$MD5" | md5sum -c - ; then
808 exit 1
809 fi
810 if [ $2 != MD5SUMS ] ; then
811 echo `grep "$MD5" MD5SUMS` >> MD5SUMS-$VERSION
812 fi
813
814 # If we make it this far we should copy the freshly downloaded file
815 # to the source archive.
816 if [ ! -z ${SRC_ARCHIVE} ] &&
817 [ -d ${SRC_ARCHIVE} ] &&
818 [ -w ${SRC_ARCHIVE} ] &&
819 [ $2 != MD5SUMS ]; then
820 echo "Store file:<$2> in package archive"
821 cp -v $2 ${SRC_ARCHIVE}
822 fi
823
824}
825
826
827#----------------------------#
828get_sources() {
829#----------------------------#
830
831 # Test if the packages must be downloaded
832 if [ "$HPKG" = "1" ] ; then
833
834 # This variable is necessary to make sure the `cat $JHALFSDIR/packages`
835 # separates each iteration by lines.
836 # Modify the 'internal field separator' to break on 'LF' only
837 IFS=$'\x0A'
838
839 if [ ! -d $BUILDDIR/sources ] ; then mkdir $BUILDDIR/sources ; fi
840 cd $BUILDDIR/sources
841 if [ -f MD5SUMS ] ; then rm MD5SUMS ; fi
842 if [ -f MD5SUMS-$VERSION ] ; then rm MD5SUMS-$VERSION ; fi
843 if [ -f MISSING_FILES.DMP ] ; then rm MISSING_FILES.DMP ; fi
844
845 download "" MD5SUMS
846
847 # Iterate through each package and grab it, along with any patches it needs.
848 for i in `cat $JHALFSDIR/packages` ; do
849 PKG=`echo $i | sed -e 's/-version.*//' -e 's/-file.*//'`
850
851 # There are some entities that aren't valid packages.
852 if [ "$PKG" = "expect-lib" -o "$PKG" = "linux-dl" ] ; then continue ; fi
853
854 VRS=`echo $i | sed -e 's/.* //' -e 's/"//g'`
855 case $PKG in
856 tcl) FILE="$PKG$VRS-src.tar.bz2" ;;
857 vim-lang) PKG="vim"
858 FILE="vim-$VRS-lang.tar.bz2" ;;
859 udev-config) PKG="udev"
860 FILE="$VRS" ;;
861 *) FILE="$PKG-$VRS.tar.bz2" ;;
862 esac
863 download $PKG $FILE
864
865 # Download any associated patches
866 for patch in `grep "&$PKG-version" $JHALFSDIR/patches` ; do
867 PATCH=`echo $patch | sed 's@&'$PKG'-version;@'$VRS'@'`
868 download $PKG $PATCH
869 done
870 done
871 if [[ -s $BUILDDIR/sources/MISSING_FILES.DMP ]]; then
872 echo -e "\n\n${tab_}${RED} One or more files were not retrieved.\n${tab_} Check ${L_arrow}$BUILDDIR/sources/MISSING_FILES.DMP${R_arrow} for names ${OFF}\n\n"
873 fi
874 fi
875}
876
Note: See TracBrowser for help on using the repository browser.